unit uEditFlags;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, RegExt;

type
  TfrmEditFlags = class(TForm)
    GroupBox1: TGroupBox;
    chbHideType: TCheckBox;
    chbNoEditContent: TCheckBox;
    chbNoEditType: TCheckBox;
    chbNoRemoveType: TCheckBox;
    chbNoNewAction: TCheckBox;
    chbNoEditAction: TCheckBox;
    chbNoRemoveAction: TCheckBox;
    chbNoDesc: TCheckBox;
    chbNoIcon: TCheckBox;
    chbNoDefault: TCheckBox;
    chbDownload: TCheckBox;
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    Memo1: TMemo;
    Label1: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure chbHideTypeEnter(Sender: TObject);
    procedure chbNoEditContentEnter(Sender: TObject);
    procedure chbNoEditTypeEnter(Sender: TObject);
    procedure chbNoRemoveTypeEnter(Sender: TObject);
    procedure chbNoNewActionEnter(Sender: TObject);
    procedure chbNoEditActionEnter(Sender: TObject);
    procedure chbNoRemoveActionEnter(Sender: TObject);
    procedure chbNoDescEnter(Sender: TObject);
    procedure chbNoIconEnter(Sender: TObject);
    procedure chbNoDefaultEnter(Sender: TObject);
    procedure chbDownloadEnter(Sender: TObject);
    procedure Label1Click(Sender: TObject);
  private
    FEditFlags : TRegEditFlagsSet;
    procedure SetEditFlags(Value: TRegEditFlagsSet);
  public
    property EditFlags : TRegEditFlagsSet read FEditFlags write SetEditFlags;
  end;

var
  frmEditFlags : TfrmEditFlags;  

implementation

{$R *.DFM}

procedure TfrmEditFlags.SetEditFlags(Value: TRegEditFlagsSet);
begin
  FEditFlags := Value;
  chbHideType.Checked := efHideType in FEditFlags;
  chbNoEditContent.Checked := edNoContentType in FEditFlags;
  chbNoEditType.Checked := edNoEditType in FEditFlags;
  chbNoRemoveType.Checked := efNoRemoveType in FEditFlags;
  chbNoNewAction.Checked := efNoNewAction in FEditFlags;
  chbNoEditAction.Checked := efNoEditAction in FEditFlags;
  chbNoRemoveAction.Checked := edNoRemoveAction in FEditFlags;
  chbNoDesc.Checked := efNoDescription in FEditFlags;
  chbNoIcon.Checked := edNoChangeIcon in FEditFlags;
  chbNoDefault.Checked := efNoSetDefault in FEditFlags;
  chbDownload.Checked := efNoOpenSave in FEditFlags;
end;

procedure TfrmEditFlags.Button2Click(Sender: TObject);
begin
  if chbHideType.Checked then Include(FEditFlags,efHideType)
                         else Exclude(FEditFlags,efHideType);
  if chbNoEditContent.Checked then Include(FEditFlags,edNoContentType)
                              else Exclude(FEditFlags,edNoContentType);
  if chbNoEditType.Checked then Include(FEditFlags,edNoEditType)
                           else Exclude(FEditFlags,edNoEditType);
  if chbNoRemoveType.Checked then Include(FEditFlags,efNoRemoveType)
                             else Exclude(FEditFlags,efNoRemoveType);
  if chbNoNewAction.Checked then Include(FEditFlags,efNoNewAction)
                            else Exclude(FEditFlags,efNoNewAction);
  if chbNoEditAction.Checked then Include(FEditFlags,efNoEditAction)
                             else Exclude(FEditFlags,efNoEditAction);
  if chbNoRemoveAction.Checked then Include(FEditFlags,edNoRemoveAction)
                               else Exclude(FEditFlags,edNoRemoveAction);
  if chbNoDesc.Checked then Include(FEditFlags,efNoDescription)
                       else Exclude(FEditFlags,efNoDescription);
  if chbNoIcon.Checked then Include(FEditFlags,edNoChangeIcon)
                       else Exclude(FEditFlags,edNoChangeIcon);
  if chbNoDefault.Checked then Include(FEditFlags,efNoSetDefault)
                          else Exclude(FEditFlags,efNoSetDefault);
  if chbDownload.Checked then Include(FEditFlags,efNoOpenSave)
                         else  Exclude(FEditFlags,efNoOpenSave);
end;

procedure TfrmEditFlags.chbHideTypeEnter(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add('  [efHideType] - Hide type in the list of the Registered File Types');
end;

procedure TfrmEditFlags.chbNoEditContentEnter(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add('  [edNoContentType] - Disable "Content Type (MIME)" combo box in the "Edit File Type" dialog');
end;

procedure TfrmEditFlags.chbNoEditTypeEnter(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add('  [edNoEditType] - Disable "Edit" button in the "File Types" tab of the Explorer "Folder Options" dialog.');
end;

procedure TfrmEditFlags.chbNoRemoveTypeEnter(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add('  [efNoRemoveType] - Disable "Remove" button in the "File Types" tab of the Explorer "Folder Options" dialog.');
end;

procedure TfrmEditFlags.chbNoNewActionEnter(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add('  [efNoNewAction] - Disable "New" button in the "Edit File Type" dialog to forbid adding new actions into context menu of the file type');
end;

procedure TfrmEditFlags.chbNoEditActionEnter(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add('  [efNoEditAction] - Disable "Edit" button in the "Edit File Type" dialog to forbid modifying actions in context menu of the file type');
end;

procedure TfrmEditFlags.chbNoRemoveActionEnter(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add('  [edNoRemoveAction] - Disable "Remove" button in the "Edit File Type" dialog to forbid removing actions in context menu of the file type');
end;

procedure TfrmEditFlags.chbNoDescEnter(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add('  [efNoDescription] - Disable "Description of type" edit box in the "Edit File Type" dialog');
end;

procedure TfrmEditFlags.chbNoIconEnter(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add('  [edNoChangeIcon] - Disable "Change Icon" button in the "Edit File Type" dialog');
end;

procedure TfrmEditFlags.chbNoDefaultEnter(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add('  [efNoSetDefault] - Disable "Set Default" button in the "Edit File Type" dialog');
end;

procedure TfrmEditFlags.chbDownloadEnter(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add('  [efNoOpenSave] - Don''t show Open/Save dialog when downloading files of this type in Microsoft Internet Explorer. Files of this type will always be opened automatically.');
end;

procedure TfrmEditFlags.Label1Click(Sender: TObject);
begin
  chbDownload.SetFocus;
  chbDownload.Checked := not chbDownload.Checked;
end;

end.
